package org.gcube.dataanalysis.executor.rscripts;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import org.gcube.dataanalysis.ecoengine.datatypes.PrimitiveType;
import org.gcube.dataanalysis.ecoengine.datatypes.StatisticalType;
import org.gcube.dataanalysis.ecoengine.datatypes.enumtypes.PrimitiveTypes;
import org.gcube.dataanalysis.executor.rscripts.generic.GenericRScript;
import org.gcube.dataanalysis.ecoengine.utils.DynamicEnum;
import java.lang.reflect.Field;

public class JavaBlackBox extends GenericRScript {

	@Override
	public String getDescription() {
		return "JavaBlackBox";
	}

	protected void initVariables(){
		mainScriptName="JavaBlackBox/Main.R";
		packageURL="http://data.d4science.org/SEZBekNTU011c2Y3NkFFb2dIU0hQOEN3aURXZDQ3ZzVHbWJQNStIS0N6Yz0";
		environmentalvariables = new ArrayList<String>();
		inputvariables.add("ClassToRun");
		inputvariables.add("PInput1");
		outputvariables.add("POutput1");
	}

	@Override
	protected void setInputParameters() {
		inputs.add(new PrimitiveType(String.class.getName(), null,PrimitiveTypes.STRING, "ClassToRun", "The class inside the jar file that contains the main method. This should be the first parameter", "SimpleProducer"));
		inputs.add(new PrimitiveType(String.class.getName(), null,PrimitiveTypes.STRING, "PInput1", "Parameter Input 1", "TestJavaOk"));
	}

	@Override
	public StatisticalType getOutput() {
		output.put("POutput1",new PrimitiveType(File.class.getName(), new File(outputValues.get("POutput1")), PrimitiveTypes.FILE, "POutput1", "POutput1"));
		PrimitiveType o = new PrimitiveType(LinkedHashMap.class.getName(), output, PrimitiveTypes.MAP, "Output", "");
		return o;
	}
}
